<template>
  <div style="margin-top: 9rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton
        :offsetArrow="20"
        :spanTitle="3"
        title="Ir a Materiales"
        v-on:clickEvent="viewListReview"
        style="margin-bottom:2.5rem"
      />
      <el-row :gutter="20">
        <!-- FILTROS DE BUSQUEDA -->
        <el-col :span="18" class="text-end">
          <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
        </el-col>
        <el-col :span="6">
          <app-search-filter v-model="textSearch"></app-search-filter>
        </el-col>
      </el-row>
    </header>
    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
      <Title :Title="'REVISIÓN DE '+ matType + ' - '+typeMaterialR"></Title>
    </div>
    <!-- CUADRADITOS DE INFORMACION DEL ESTADO DE LOS PEDIDOS -->
    <!-- Leyenda -->
    <div style="margin:3rem 10rem">
      <el-row type="flex" justify="space-between">
        <div>
          <h4 style="margin-bottom: 10px">{{typeMaterialR}} SIN CAPÍTULOS</h4>
          <el-col style="margin: 8px 0" v-for="(item, index) in withoutCaps" :key="index">
            <div class="flex element-bloq-center">
              <div
                :class="item.style"
                class="border-radius-light"
                style="margin-right:1rem; height:25px; width:25px"
              ></div>
              <span>{{item.name}}</span>
            </div>
          </el-col>
        </div>
        <div style="width: 70%">
          <h4 style="margin-bottom: 10px">{{typeMaterialR}} CON CAPÍTULOS</h4>
          <el-col style="margin: 8px 0" v-for="(item, index) in withCaps" :key="index">
            <div class="flex element-bloq-center">
              <div
                :class="item.style"
                class="border-radius-light"
                style="margin-right:1rem; height:25px; width:25px"
              ></div>
              <span>{{item.name}}</span>
            </div>
          </el-col>
        </div>
      </el-row>
    </div>
    <el-main style="margin:3rem 5rem">
      <el-row>
        <el-col
          v-for="(material, index) in materials.slice(0,30)"
          :key="index"
          :span="18"
          :offset="3"
          style="margin-bottom: 4rem"
        >
          <app-card-review
            :rutaImg="getImgUrl(image)"
            :showRate="true"
            :itemPrincipal="material"
            :shadowBox="(material.typeOfContent == 'Novelas' || material.typeOfContent == 'TELENOVELA' || material.typeOfContent == 'TELEVISA - TELENOVELAS')?'pink-shadow':((material.typeOfContent == 'TELEVISA - SERIES' || material.typeOfContent == 'SERIE' || material.typeOfContent == 'Series')?'skyblue-shadow':'yellow-shadow')"
            :imgStyle="'icon-card'"
            :detailsData="{
                        0:{subtitle: 'Código de Material', content: material.codMaterial},
                        1:{subtitle: 'Código de Géminis', content: material.geminisCode},
                        2:{subtitle: 'Proveedor', content: material.providerName},
                        3:{subtitle: 'Cod. Proveedor', content: material.providerCode},
                        4:{subtitle: 'Cod. Contrato', content: material.contractCode},
                    }"
            :detailsData2="details(material)"
            :btnGroup="{
                        0:{validationBtnShow: material.reviewStatus === 'withoutChecking', btnClass: 'b-grey t-grey', btnTextAction: 'SIN REVISAR', editVal: 'selectedMaterial', newVal: 'newCards'},  
                        1:{validationBtnShow: material.reviewStatus === 'approved2', btnClass: 'b-blue t-blue', btnTextAction: 'NO EMITIDO', editVal: 'selectedMaterial', newVal: 'newCards'},
                        2:{validationBtnShow: material.reviewStatus === 'live', btnClass: 'b-green t-green', btnTextAction: 'AL AIRE', editVal: 'selectedMaterial', newVal: 'newCards'},
                        3:{validationBtnShow: material.reviewStatus === 'transmitted', btnClass: 'b-orange t-orange', btnTextAction: 'EMITIDO', editVal: 'selectedMaterial', newVal: 'newCards'},
                        5:{validationBtnShow: material.reviewStatus === 'approved', btnClass: 'border-green text-green', btnTextAction: 'APROBADO', editVal: 'selectedMaterial', newVal: 'newCards'},
                        6:{validationBtnShow: material.reviewStatus === 'pending', btnClass: 'border-red text-red', btnTextAction: 'PENDIENTE', editVal: 'selectedMaterial', newVal: 'newCards'},
                        7:{validationBtnShow: material.reviewStatus === 'incomplete', btnClass: 'border-orange text-orange', btnTextAction: 'INCOMPLETO', editVal: 'selectedMaterial', newVal: 'newCards'},
                        8: {validationBtnShow: material.reviewStatus === 'incompleteStyle', btnClass: 'b-purple t-purple', btnTextAction: 'INCOMPLETO', editVal: 'selectedMaterial', newVal: 'newCards'}
                    }"
          />
        </el-col>
      </el-row>
    </el-main>
  </div>
</template>
<script>
import Title from '@/components/Title.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import DescriptionStateOrders from '@/components/DescriptionStateOrders.vue'
import { HTTP } from '@/main.js'
import CardReview from '@/components/cardReview'
import { modifyText } from '@/utils/modifyText.js'

export default {
  components: {
    Title,
    ReturnButton,
    'app-search-filter': SearchFilter,
    'app-select': Select,
    DescriptionStateOrders,
    'app-card-review': CardReview,
  },
  data() {
    return {
      typeMaterialR: '',
      matType: localStorage.getItem('classification'),
      filterSelect: '',
      allFilters: [
        { value: 'providerCode', label: 'Código Proveedor' },
        { value: 'codMaterial', label: 'Código de Material' },
      ],
      textSearch: '',
      allMateriales: [],
      image: '',
      typeOfContent: localStorage.getItem('typeOfContent'),
      withCaps: [
        { style: 'l-grey', name: 'Sin Revisar' },
        { style: 'l-blue', name: 'Aprobado, pero no emitido' },
        { style: 'l-green', name: 'Aprobado y Al aire' },
        { style: 'l-orange', name: 'Aprobado y Emitido' },
        { style: 'l-purple', name: 'Imcompleto' },
      ],
      withoutCaps: [
        { style: 'l-grey', name: 'Sin Revisar' },
        { style: 'l-green', name: 'Revisión Aprobada' },
        { style: 'bg-red', name: 'Pendiente de Reposición' },
        { style: 'l-orange', name: 'Datos incompletos, pero aprobado' },
      ],
    }
  },
  created() {
    this.typeMaterialR = this.typeOfContent.toUpperCase()
    this.getMaterial()
    this.image = this.asignedImage(this.typeOfContent)
  },
  computed: {
    materials() {
      let movies = this.allMateriales

      if (this.textSearch) {
        movies = movies.filter(
          (m) =>
            modifyText(m.originalTitle).indexOf(modifyText(this.textSearch)) >
              -1 ||
            modifyText(m.ownTitle).indexOf(modifyText(this.textSearch)) > -1 ||
            modifyText(m.listTitle).indexOf(modifyText(this.textSearch)) > -1
        )
      }

      if (this.filterSelect && this.textSearch) {
        movies = this.allMateriales.filter(
          (m) =>
            modifyText(m[this.filterSelect]).indexOf(
              modifyText(this.textSearch)
            ) !== -1
        )
      }
      return movies
    },
  },
  methods: {
    getImgUrl(pic) {
      return require('@/assets/images/' + pic)
    },
    asignedImage(type) {
      let transformType = type.toLowerCase()
      let image
      switch (transformType) {
        case 'cocina':
          image = 'icono-cocina.svg'
          break
        case 'largometrajes':
          image = 'largometraje.svg'
          break
        case 'novelas':
          image = 'novela.svg'
          break
        case 'series':
          image = 'serie.svg'
          break
        case 'miniseries':
          image = 'miniserie.svg'
          break
        case 'dibujos':
          image = 'dibujo.svg'
          break
        case 'especial':
          image = 'especiales.svg'
          break
        case 'deportes':
          image = 'icono-deportivo.svg'
          break
        case 'programas especiales':
          image = 'icono-progespeciales.svg'
          break
        default:
          image = `icono-${transformType}.svg`
          break
      }
      return image
    },
    viewListReview() {
      this.$router.push({
        name: 'materialesEnlatados',
        params: { canned: true },
      })
    },
    getMaterial(material, value) {
      HTTP.get(
        'materials/materialType/Enlatado/typeOfContent/' +
          this.typeOfContent +
          '/providerName'
      )
        .then(async (res) => {
          this.allMateriales = this.orderDataByGeminisCode(res.data.materials)
        })
        .catch((err) => {
          console.log(err)
        })
    },
    details(value) {
      let object
      if (value.numChapters.length > 0) {
        object = {
          0: {
            subtitle: 'Temporada',
            content: value.numChapters.map((i) => i.season).join(' - '),
          },
          1: {
            subtitle: 'Género',
            content: value.reviewObj
              ? value.reviewObj.genre2
                ? value.reviewObj.genre1
                  ? value.reviewObj.genre1 + ' / ' + value.reviewObj.genre2
                  : value.reviewObj.genre2
                : value.reviewObj.genre1
              : '',
          },
          2: {
            subtitle: 'Clasificación',
            content: value.reviewObj ? value.reviewObj.classification : '',
          },
          3: {
            subtitle: 'Actores',
            content:
              value.reviewObj && value.reviewObj.artisticInfo
                ? value.reviewObj.artisticInfo[0].mainActors.join(', ')
                : '',
          },
        }
      } else {
        object = {
          0: {
            subtitle: 'Género',
            content: value.reviewObj
              ? value.reviewObj.genre2
                ? value.reviewObj.genre1
                  ? value.reviewObj.genre1 + ' / ' + value.reviewObj.genre2
                  : value.reviewObj.genre2
                : value.reviewObj.genre1
              : '',
          },
          1: {
            subtitle: 'Clasificación',
            content: value.reviewObj ? value.reviewObj.classification : '',
          },
          2: {
            subtitle: 'Equitetas',
            content: value.reviewObj
              ? value.reviewObj.dynamicTags.join(', ')
              : '',
          },
          3: {
            subtitle: 'Actores',
            content:
              value.reviewObj && value.reviewObj.artisticInfo
                ? value.reviewObj.artisticInfo[0].mainActors.join(', ')
                : '',
          },
        }
      }
      return object
    },
    orderDataByGeminisCode(array) {
      array.sort(function (a, b) {
        if (Number(a.geminisCode) < Number(b.geminisCode)) {
          return 1
        }
        if (Number(a.geminisCode) > Number(b.geminisCode)) {
          return -1
        }
        return 0
      })
      return array
    },
    async addPositionInContract(data) {
      let response = await data.map(async (e) => {
        let {
          contractPosition,
          stringMaterialType,
          originalTitle,
          contractCode,
          codMaterial,
          typeOfContent,
        } = e
        if (contractPosition == '' || !contractPosition) {
          let position = await HTTP.post('contracts/findPositionContract', {
            contractCode,
            material: { codMaterial, typeOfContent },
          })
          this.$set(e, 'contractPosition', position.data.position)
        }
      })
      return response
    },
  },
}
</script>